#include <windows.h>
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "dir.h"

#include "plugin.hpp"

#define DEBUGS(x) MessageBox(NULL, x, "FARMail", MB_OK );
#define DEBUGI(x) { char ___buf[100]; sprintf( ___buf, "%ld", (long)(x) ); MessageBox(NULL, ___buf, "FARMail", MB_OK ); }

#define LINT_ARGS
#define PRINTING_LINE_NUMBER
#define NESTED_COMMENTS

#define TRUE 1
#define FALSE 0
#define OK      0

#define BRACES -2
#define PARENS -3
#define QUOTES -4
#define TEMPLT -5
#define SQB    -6
#define DEFINE -7


#define MAXLINE 8192

#define DPTRSIZE 100

#define STABLE        0
#define IN_CMT_FS     1
#define OUT_CMT_STAR  2
#define LINE_CMT      3

#define LINE_LEN 8192
#define MAXFILTER 20


typedef enum TYPES_PROJECT
{
 UNDEF_PROJECT = 0,  // ஥
 C_PROJECT     = 1,  //c,c++ ஥
 RSL_PROJECT   = 2   //rsl ஥

}TYPES_PROJECT;

typedef struct FarMenuItem FARMENU;

typedef struct tagFUNC 
{
   char Func[64];
   char Path[64];
   WORD Line;
   FILETIME ftLastWriteTime;

} FUNC;


typedef struct tagFCSBPARM {

 char     curdirec[MAX_PATH];
 int      line_num;
 int      filecount;
 FUNC    *fptr;
 FARMENU *mptr;
 long     ptrsize;
 long     itemnum;
 char     FILEOUT[13];
 int      vk_underline;
 int      vk_semicol;
 int      vk_not;
 int      vk_less;
 int      vk_grt;

 int      CountStatic;
 int      CountInline;
 int      CountCPP;
 int      ExitMenu;

 int      Editor;
 int      StringNumber;
 int      CharNumber;
 int      MaxCurLen;
 char *   CurLinePtr;

 char     FileMask[512];
 int      Recurse;
 int      MoveToFun;

 FUNC     *fptru;
 long     LastUnsortItemMum;
 long     UnsortItemNum;
 long     UnsortPtrSize;
 int      ExistUnsortList;

 TYPES_PROJECT TypeProject; //⨯ ஥: C_PROJECT - , RSL_PROJECT - rsl  
 char     define[MAXLINE + 1]; //ப, ᮤঠ #define

 WIN32_FIND_DATA *fd;
 bool     is_enum;

 unsigned long NumChangedFiles;
 bool     skip_one_first_curly_braces; //ਧ ஡ ࠧ { }

 int IsFilePrj; //ਧ ⮣,  뢠 䠩  ᯨ᪮ 㭪権 ஥, ᤥ FCSB
 unsigned long NumStr; // ப   㦭 ३  ⨨ 䠩  ।
 int num_find_funs; //-  ।  ० 室  㭪樨
 char PathRootPrj[1024];      /*     ஥*/
 char FilePath[MAXPATH];//   ⥪饣 䠩


} FCSBPARM;


struct InitDialogItem
{
  unsigned char Type;
  unsigned char X1,Y1,X2,Y2;
  unsigned char Focus;
  unsigned int Selected;
  unsigned int Flags;
  unsigned char DefaultButton;
  char *Data;
};



extern "C"
{
  void WINAPI   _export SetStartupInfo(const struct PluginStartupInfo *Info);
  HANDLE WINAPI _export OpenPlugin(int OpenFrom,int Item);
  void WINAPI   _export GetPluginInfo(struct PluginInfo *Info);
  int WINAPI    _export Configure(int ItemNumber);
};

void SetRegKey(HKEY hRoot,char *Key,char *ValueName,DWORD ValueData);
void SetRegKey(HKEY hRoot,char *Key,char *ValueName,char *ValueData);
int GetRegKey(HKEY hRoot,char *Key,char *ValueName,int &ValueData,DWORD Default);
int GetRegKey(HKEY hRoot,char *Key,char *ValueName,DWORD Default);
int GetRegKey(HKEY hRoot,char *Key,char *ValueName,char *ValueData,char *Default,DWORD DataSize);
int Config( void );
const char *GetMsg(int MsgId);

extern char     PluginRootKey[80];
extern char     CTSTATIC[]  ;
extern char     CTINLINE[]  ;
extern char     CTCPP[]     ;
extern char     QUITMENU[]  ;
extern char     CONTENTS[]  ;
extern char     OPERATOR[]  ;
extern char     CTSTATICE[] ;
extern char     CTINLINEE[] ;
extern char     CTCPPE[]   ;
extern char     DEFAULTFILEMASK[];
extern char     FILEMASK[];
extern char     RECURSE[];
extern char     MOVETOFUN[];

extern struct   PluginStartupInfo _Info;


enum
{
  MesMenu = 0,
  MesMenuRun,
  MesMenuScan,
  MesMenuGoToFun,
  MesReturnAfterGoToFun,
  MNoFindFun,
  MesErrHead,
  MesErrMemory,
  MesOk,
  MesMenuHead,
  MesMenuStatus,
  MesProcScan,
  MesProcDone,
  MesProcSort,
  MesProcSort2,
  MesProcSort3,
  MesSearchChanges,
  MesProcFileRd,
  MesProcFileRd2,
  MesNoFiles,
  MesVersion,
  MesConfig,
  MesC1,
  MesC2,
  MesC3,
  MesC4,
  MesC5,
  MesC6,
  MesC7,
  MesC8,
  MesC9,
  MesC10,
  MesC11,
};
